      subroutine fill_params (mode, nfiles, nids_tot, nids, fids, ids,
     $     ts, ps, os, xs, ys, mags, pft_ccs, prj_ccs, cmp_ccs,
     $     param_fnames)

C     Fill index, orientation ,origin, etc. arrays by reading data from
C     parameter files. If abs(mode) is equal to one, simply set the
C     index and file id for every particle in the image files.
C
C     February 1998 purdue university alphastation 500/400, t. baker.
C     Modified 26-may-1998 by rwa/tsb (bug in nn variable).
C     Modified 5/31/07 by RSS, general cleanup

      implicit none

      integer, intent(in) :: mode, nfiles, nids_tot, nids(999)
      character(len=256), intent(in) ::  param_fnames(999)

      integer, intent(out) :: fids(nids_tot), ids(nids_tot)
      real, intent(out)    :: ts(nids_tot), ps(nids_tot), os(nids_tot)
      real, intent(out)    :: xs(nids_tot), ys(nids_tot), mags(nids_tot)
      real, intent(out)    :: pft_ccs(nids_tot), prj_ccs(nids_tot)
      real, intent(out)    :: cmp_ccs(nids_tot)

      integer id, file, nn, ids_tot, ios
      character(len=100) :: heading

C     Option 1: |mode| equal to 1
C     Set index and file ID for all particle images in image files
      if(iabs(mode) == 1) then
         ids_tot = 0
         do file = 1, nfiles
            do id = 1, nids(file)
               ids_tot       = ids_tot + 1
               ids(ids_tot)  = id
               fids(ids_tot) = file
            enddo
         enddo
      endif

C     Option 2: |mode| not equal to 1
C     Read indices, orientations, origins, etc. from ptle parameter files
      if(iabs(mode) .ne. 1) then
         nn = 1
         do file = 1, nfiles
            open(unit=19, file=param_fnames(file), iostat=ios)
            if(ios .ne. 0) then
               write(*,*) 'Unable to open file in fill_params'
               write(*,*) trim(param_fnames(file))
               call tsbend
            endif

            read(19,'(A)') heading
            read(19,'(A)') heading

            do
               read (19,*,iostat=ios) ids(nn), ts(nn), ps(nn), os(nn),
     $              xs(nn),ys(nn), mags(nn), pft_ccs(nn), prj_ccs(nn),
     $              cmp_ccs(nn)
               if(ios < 0) then ! Reached EOF
                  exit
               else if(ios > 0) then ! Error during read
                  write(*,*) 'Error during read of file in fill_params'
                  write(*,*) trim(param_fnames(file))
               else             ! Successfully read record
                  fids(nn) = file
                  nn = nn + 1
               endif
            enddo

            close(19)
         enddo
      endif
      
      return
      end subroutine fill_params
