      subroutine get_1st_ortid(id, file_name) 

C     Get the id for the first particle in a parameter file

      implicit none

      character*(*), intent(in) :: file_name
      integer, intent(out)      :: id

      character(len=100) ::  heading
      integer ios

      open (unit=3, file= file_name)

C     Read in and discard header lines
      read(3,'(A)') heading
      read(3,'(A)') heading

C     Read in id for first particle
      read(3, *, iostat=ios) id
      if(ios .ne. 0) then
         print *, '+++++ Warning from get_1st_ortid'
         print *, 'Parameter file contains no ptles, set 1st ID to 0'
         id = 0
      elseif(id .le. 0) then
         print *, '+++++ Warning from get_1st_ortid'
         print *, 'Error in parmeter file, set 1st ID to 0'
         id = 0
      endif

      close(unit=3)

      return
      end subroutine get_1st_ortid
