#ifndef _FIT_UTILS_H_
#define _FIT_UTILS_H_

void mrqmin_1d (double x[], double y[], double sig[], int ndata, 
		double a[], int ia[],
		int ma, double **covar, double **alpha, double *chisq,
		void (*funcs)(double, double [], double *, 
			      double [], int, int, int, double,
			      int, double, double, double, int, int),
		double *alamda, int num_gauss_bkg, int num_gauss_ctf, 
		double wavelength,
		int idim_half, double A, double Cs, 
		double pixel_size, int *nmfit, int annlow, int annhigh);

void fpoly_ctf_1d (double  x, double  a[], double  *y, double  dyda[], 
		   int na, int order_poly1,
		   int order_poly2, double  wavelength, int idim_half, 
		   double  A, double  Cs,
		   double  pixel_size, int annlow, int annhigh );

void cmpt_fit1d(double ca1d_avg[], double ca1d_std[], int * ndata,
		int *annlow, int *annhigh,
		double poly_paras[], int * poly_order, int * poly_orderb, 
		int * poly_orderd,
		double * wavelength, int * hkl_max, double * A, double * Cs,
		double * pixel_size, double * chisq);

void cmpt_fit1d_(double ca1d_avg[], double ca1d_std[], int * ndata,
		 int *annlow, int *annhigh,
		 double poly_paras[], int * poly_order, int * poly_orderb, 
		 int * poly_orderd,
		 double * wavelength, int * hkl_max, double * A, double * Cs,
		 double * pixel_size, double * chisq);

void covsrt_1d(double **covar, int ma, int ia[], int mfit);
void gaussj_1d(double **a, int n, double **b, int m);
void mrqcof_1d(double x[], double y[], double sig[], int ndata, double a[],
	       int ia[], int ma, double **alpha, double beta[], double *chisq,
	       void(*funcs)(double, double [], double *, double [], int, 
			    int, int, double,
			    int, double, double, double, int, int),
	       int num_gauss_bkg, int num_gauss_ctf,double wavelength,
	       int idim_half,
	       double A, double Cs, double pixel_size, 
	       int annlow, int annhigh);
void lubksb_1d(double **a, int n, int *indx, double b[]);
void ludcmp_1d(double **a, int n, int *indx, double *d);
void invmatrix_1d(double **a, double **y, int n);
double condnumcal_1d(double **matrix, double **alpha, int n);
double normcal_1d (double ** matrix, int n);



#endif
